<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" [
  <!ENTITY % htmlpurifier.current SYSTEM "current.ent"> %htmlpurifier.current;
]>
<html xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xc="urn:xhtml-compiler"
  xml:lang="en">
<head>
  <title>Comparison - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, HTML_Safe, PEAR, comparison, kses, striptags, SafeHTMLChecker" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">Comparison</h1>

<div id="content">

<p>
  With the advent of <a href="http://en.wikipedia.org/wiki/Web_2.0">Web 2.0</a>,
  the end user has gone from passive consumer to active producer of content
  on the World Wide Web.  <a href="http://en.wikipedia.org/wiki/Wiki">Wikis</a>,
  <a href="http://en.wikipedia.org/wiki/Social_software">Social Software</a> and
  <a href="http://en.wikipedia.org/wiki/Blog">Blogs</a> all put the user in control.
</p>

<p>
  Give the user too much control, however, and you set yourself up for <a 
  href="http://en.wikipedia.org/wiki/Cross-site_scripting"><abbr>XSS</abbr 
  ></a> attacks. For this reason, <abbr>HTML</abbr>'s flexibility has 
  proven to be both a blessing and a curse, and the software that 
  processes it must strike a fine balance between security and usability. 
  How do we prevent users from injecting JavaScript or inserting malformed 
  <abbr>HTML</abbr> while allowing a rich syntax of tags, attributes and 
  <abbr>CSS</abbr>? How do we put <abbr>HTML</abbr> inside 
  <abbr>RSS</abbr> feed without worrying about sloppy coding messing up 
  <abbr>XML</abbr> parsing? Almost every <abbr>PHP</abbr> developer has 
  come across this problem before, and many have tried (albeit 
  unsuccessfully) to solve this problem. We will analyze existing 
  libraries to demonstrate how they are ineffective and, of course, how 
  <strong>HTML Purifier</strong> solves all our problems and achieves 
  standards-compliance. 
</p>

<p>
  I will take no quarter and pull no punches: as of the time of writing,
  no other library comes even <em>close</em> to solving the problem effectively
  for richly formatted documents.  But, nonetheless, there is a necessary
  disclaimer:
</p>

<div class="disclaimer">
  <p>
    This comparison document was written by the author of HTML Purifier,
    and clearly is <strong>in favor</strong> of HTML Purifier. However, that doesn't
    mean that it is biased: I have made every attempt to be <strong>factual and
    fair</strong>, and I hope that you will agree, by the time you finish reading
    this document, that HTML Purifier is the only satisfactory <abbr>HTML</abbr>
    filter out there today.
  </p>
</div>

<div id="toc" />

<h2 id="Summary">Summary</h2>

<p>A table summarizing the differences for the impatient.</p>

<div class="wide-table">
<table cellspacing="0">

<thead>
  <tr>
    <th>Library</th>
    <th>Version</th>
    <th>Date</th>
    <th>License</th>
    <th>Whitelist</th>
    <th>Removal</th>
    <th>Well-formed</th>
    <th>Nesting</th>
    <th>Attributes</th>
    <th>XSS&nbsp;safe</th>
    <th>Standards&nbsp;safe</th>
  </tr>
</thead>

<tbody>

<tr>
  <td>striptags</td>
  <td>n/a</td>
  <td>n/a</td>
  <td>n/a</td>
  <td class="impl-almostyes">Yes (user)</td>
  <td class="impl-partial">Buggy</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
</tr>

<tr>
  <td>PHP Input Filter</td>
  <td>1.2.2</td>
  <td>2005-10-05</td>
  <td>GPL</td>
  <td class="impl-almostyes">Yes (user)</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-almostyes">Probably</td>
  <td class="impl-no">No</td>
</tr>

<tr>
  <td>HTML_Safe</td>
  <td>0.9.9beta</td>
  <td>2005-12-21</td>
  <td>BSD (3)</td>
  <td class="impl-no">Mostly No</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-no">No</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-almostyes">Probably</td>
  <td class="impl-no">No</td>
</tr>

<tr>
  <td>kses</td>
  <td>0.2.2</td>
  <td>2005-02-06</td>
  <td>GPL</td>
  <td class="impl-almostyes">Yes (user)</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-no">No</td>
  <td class="impl-no">No</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-almostyes">Probably</td>
  <td class="impl-no">No</td>
</tr>

<tr>
  <td>htmLawed</td>
  <td>1.1.9.1</td>
  <td>2009-02-26</td>
  <td>GPL</td>
  <td class="impl-partial">Yes (not default)</td>
  <td class="impl-almostyes">Yes (user)</td>
  <td class="impl-almostyes">Yes (user)</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-almostyes">Probably</td>
  <td class="impl-no">No</td>
</tr>

<tr>
  <td>Safe HTML Checker</td>
  <td>n/a</td>
  <td>2003-09-15</td>
  <td>n/a</td>
  <td class="impl-partial">Yes (bare)</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-almostyes">Almost</td>
  <td class="impl-partial">Partial</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-almostyes">Almost</td>
</tr>

<tr>
  <td>HTML Purifier</td>
  <td>&htmlpurifier.current.version;</td>
  <td>&htmlpurifier.current.release-date;</td>
  <td>LGPL</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
  <td class="impl-yes">Yes</td>
</tr>

</tbody>

</table>
</div>

<p>
  <a href="#Tidy">HTML Tidy</a> is omitted from this list because it is not
  an <abbr>HTML</abbr> filter.
</p>

<h2 id="AltMarkup">Look Ma, No <abbr>HTML</abbr>!</h2>

<blockquote class="fancy">
  <div class="quote" style="text-align:center;">
    A clever person solves a problem.
    A wise person avoids it.
  </div>
  <div class="origin">&mdash; Albert Einstein</div>
</blockquote>

<p>
  Before we jump into the weird and not-so-wonderful world of 
  <abbr>HTML</abbr> filters, we must first consider another domain: 
  non-<abbr>HTML</abbr> markup libraries. While libraries of this type 
  really shouldn't be considered <abbr>HTML</abbr> filters, they are the 
  number one method of taking user input and processing it into something 
  more than plain old text. These libraries forgo <abbr>HTML</abbr> and 
  define their own markup syntax. <a 
  href="http://en.wikipedia.org/wiki/BBCode">BBCode</a>, <a 
  href="http://en.wikipedia.org/wiki/Wikitext">Wikitext</a>, <a 
  href="http://daringfireball.net/projects/markdown/">Markdown</a> and <a 
  href="http://textism.com/tools/textile/">Textile</a> are all examples of 
  such markup languages (although it should be noted that Wikitext and 
  Markdown can allow <abbr>HTML</abbr> within them). The benefits (to 
  those who use it, anyway) are clear: simplicity and security. 
</p>

<table cellspacing="0">
  <thead>
    <tr>
      <th>Markup language</th>
      <th>Sample</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>BBCode</th>
      <td><tt>[b]B[/b] [i]i[/i] [url = http://www.example.com/]link[/url].</tt></td>
    </tr>
    <tr>
      <th>Wikitext<sup>1</sup></th>
      <td><tt>'''B''' ''i'' [http://www.example.com/ link]</tt></td>
    </tr>
    <tr>
      <th>Markdown<sup>2</sup></th>
      <td><tt>**B** *i* [link](http://www.example.com/)</tt></td>
    </tr>
    <tr>
      <th>Textile</th>
      <td><tt>*B* _i_ &quot;link&quot;:http://www.example.com/</tt></td>
    </tr>
    <tr>
      <th><abbr>HTML</abbr></th>
      <td><tt>&lt;b&gt;B&lt;/b&gt; &lt;i&gt;i&lt;/i&gt; &lt;a href=&quot;http://www.example.com/&quot;&gt;link&lt;/a&gt;</tt></td>
  </tr>
    <tr>
      <th><acronym>WYSIWYG</acronym></th>
      <td><b>B</b> <i>i</i> <a href="http://www.example.com/">link</a></td>
    </tr>
  </tbody>
</table>

<ol class="notes">
  <li>
    Wikitext shown is modeled after <a
    href="http://www.mediawiki.org/wiki/MediaWiki">MediaWiki</a> style.
    There are many variants of Wikitext currently extant.
  </li>
  <li>
    Strictly speaking, the Markdown syntax is not equivalent: bold text
    is expressed as <code>&lt;strong&gt;</code> and italicized text is
    expressed as <code>&lt;em&gt;</code>. Most browser default stylesheets,
    however, map those two semantic tags to the associated styling, so
    many users assume that it really is italics (and use it improperly for,
    say, book titles.)
  </li>
</ol>

<h3 id="AltMarkup:Simplicity">Simplicity</h3>

<p>
  <abbr>HTML</abbr> source code is often criticized for being difficult to
  read. For example, compare:
</p>

<pre>
* Item 1
* Item 2
</pre>

<p>...with:</p>

<pre>
&lt;ul&gt;
    &lt;li&gt;Item 1&lt;/li&gt;
    &lt;li&gt;Item 2&lt;/li&gt;
&lt;/ul&gt;
</pre>

<p>
  Which would you prefer to edit? The answer seems obvious, but be careful 
  not to fall into the fallacy of <a 
  href="http://en.wikipedia.org/wiki/False_dilemma">false dilemma</a>. 
  There <em>is</em> a third choice: the <acronym>WYSIWYG</acronym> (rich 
  text) editor, which blows earlier choices out of the water in terms of 
  usability. 
</p>

<p>
  Note that rich text editors and alternate markup syntaxes are not
  mutually exclusive, but, when push comes to shove, it's easier
  implement this sort of editor on top of <abbr>HTML</abbr> than some obscure
  markup language.  And in the cases when it is done, you usually end up with
  a live preview, not a true rich text editor.
</p>

<blockquote class="digression">
  <p>
    <q>Now just wait a second,</q> you may be saying, <q><acronym>WYSIWYG</acronym> 
    editors aren't all that great.</q> There are many good arguments against 
    these editors, and <a 
    href="http://www.ideography.co.uk/library/seybold/WYSIWYG.html">intelligent
    people have written essays</a> devoted to criticizing 
    <acronym>WYSIWYG</acronym>. In addition to the usual arguments against 
    said editors, the web poses another limitation: no JavaScript means no 
    editor, and no editor means... (gasp) manually typing in code.
  </p>
  <p>
    Even the most dogmatic purist, however, should recognize that for all
    its faults, prospective clients <em>really</em> want rich text editors.
    There are steps you can take to mitigate the associated drawbacks of
    these editors.
  </p>
  <p>
    It is often asserted that <acronym>WYSIWYG</acronym> editors
    <em>encourage excessive presentational markup</em>. As it turns out,
    this is the case with any markup language that allows the smallest
    iota of presentational tags, be it <tt>&lt;font&gt;</tt> or
    <tt>[color=red]</tt>. A good way to reduce this trouble is to simply 
    eliminate the dialogue boxes that allow users to change colors or fonts
    (which usually have no legitimate use) and adopt a <acronym>WYSIWYM</acronym>
    scheme, allowing users to select contextually correct formatting styles
    for segments of text.
  </p>
</blockquote>

<p>
  Simplicity is also a double-edged sword.  The moment any remotely
  complex markup is needed, these lightweight markup languages fail to
  produce.  Sure you can make '''this text bold''' with Wikitext, but that
  infobox all <q>rendered nicely in aqua blue</q> will require a gaggle of
  &lt;div&gt;s and <abbr>CSS</abbr>. These languages face the same troubles
  as regular <abbr>HTML</abbr> filters in that their whitelist is too
  restrictive (besides the fact that their table markup is extraordinarily
  complex).
</p>

<h3 id="AltMarkup:Security">Security</h3>

<p>
  BBCode can be boiled down to a <q>wanna-be</q> version of
  <abbr>HTML</abbr>. I mean, replacing
  the angled brackets with square brackets and omitting the occasional parameter
  name? How much more un-original can you get? Somehow, I don't think BBCode
  was meant to readable. <a
  href="http://en.wikipedia.org/wiki/BBCode">Wikipedia</a> agrees:
</p>

<blockquote>
  BBCode was devised and put to use in order to provide a safer, easier
  and more limited way of allowing users to format their messages.
  Previously, many message boards allowed the users to include <abbr>HTML</abbr>,
  which could be used to break/imitate parts of the layout, or run
  JavaScript. Some implementations of BBCode have suffered problems related
  to the way they translate the BBCode into <abbr>HTML</abbr>, which could negate the
  security that was intended to be given by BBCode.
</blockquote>

<p>Or, put more simply:</p>

<blockquote>
  BBCode came to life when developers where too
  lazy to parse <abbr>HTML</abbr> correctly
  and decided to invent their own markup language. As with all products of
  laziness, the result is completely inconsistent, unstandardized, and
  widely adopted.
</blockquote>

<p>
  Well, developers, the whole point of HTML Purifier is that I do the
  work so you can just execute the ridiculously simple
  <tt>$purifier->purify($html)</tt> call and go on to do, well, whatever
  you developers do. <tt>:-P</tt>
</p>

<h3 id="AltMarkup:Conclusion">Conclusion</h3>

<p>
  These alternative markup languages have their shiny points, and HTML
  Purifier is not meant to replace them.  However, a major reason for
  their existence has been called into question.  Why are <em>you</em>
  using these languages?
</p>

<h2 id="Tidy">HTML Tidy</h2>

<p>
  Dave Raggett's
  <a href="http://www.w3.org/People/Raggett/tidy/">HTML Tidy</a> is a program;
  neat enough, at least, to make it into <abbr>PHP</abbr> as a
  <a href="http://us2.php.net/manual/en/ref.tidy.php"><abbr>PECL</abbr> extension.</a>
  The premise is simple, the execution effective. Tidy is, in short, a great
  <em>tool</em>.
</p>

<p>
  It is not, however, a filter.  I am often surprised when people ask
  me, <q>What about Tidy?</q>  There's nothing against Tidy: Tidy tackles
  a different problem set.  Let's see what <tt>man tidy</tt> has to say:
</p>

<blockquote cite="http://tidy.sourceforge.net/docs/tidy_man.html">
  Tidy reads <abbr>HTML</abbr>, <abbr>XHTML</abbr> and
  <abbr>XML</abbr> files and writes cleaned up markup. For
  <abbr>HTML</abbr> variants, it detects and corrects many common coding errors and
  strives to produce visually equivalent markup that is both <abbr>W3C</abbr> compliant
  and works on most browsers. A common use of Tidy is to convert plain <abbr>HTML</abbr>
  to <abbr>XHTML</abbr>.
</blockquote>

<p>
  Hmm... why do I not see the words <q>filter</q> or
  <q><abbr>XSS</abbr></q> in here? Perhaps it's
  because Tidy accepts <em>any</em> valid
  <abbr>HTML</abbr>.  Including
  <tt>script</tt> tags.  Which leads us to our second part: Tidy parses
  <em>documents</em>, not document <em>fragments</em>.
</p>

<p>
  This is not to say that I haven't seen Tidy be used in this sort of
  fashion.  MediaWiki, for instance, uses Tidy to cleanup the final <abbr>HTML</abbr>
  output before shuttling it off to the browser.  The developers, nevertheless,
  agree that this is only a band-aid solution, and that the real way
  to fix it is to fix the parser. Tidy's great, but in terms of security,
  it's not suitable for untrusted sources.
</p>

<h2 id="AntiSamy">OWASP AntiSamy</h2>

<p>
  Although <a href="http://www.owasp.org/index.php/Category:OWASP_AntiSamy_Project">OWASP AntiSamy</a> is implemented in Java and .NET, it is
  worth a quick mention here because it purports to do the same thing
  as HTML Purifier. The bottom line? It gets pretty close, but
  it just doesn't have the same depth as HTML Purifier.
</p>

<p>
  Architecturally speaking, OWASP AntiSamy is highly dependent on 
  what are called <q>policy files</q>, which is an highly extended form
  of <abbr>XML</abbr> Schema with information on what attributes and elements to allow. As such,
  the actual code for filtering is relatively light-weight. AntiSamy
  gets lots of points for using legitimate <abbr>HTML</abbr> and <abbr>CSS</abbr> parsers (extra
  props for the <abbr>CSS</abbr> parser; HTML Purifier doesn't use one, but we should!)
</p>

<p>
  Unfortunately, while <abbr>XML</abbr> Schema files can get a high level of
  control on the validation, the regular expression heavy approach
  begins showing signs of stress when data-types are complex (e.g.
  <abbr>URI</abbr>s), and <abbr>XML</abbr> Schema is ill-suited for large-scale <acronym>DOM</acronym> manipulation,
  which is necessary when transforming <abbr>HTML</abbr> for standards compliance.
  Nonetheless, I would be fairly confident in its <abbr>XSS</abbr> cleaning
  abilities, so long as it removes things it doesn't recognize by default
  (something I find slightly perplexing in its policy files, since some
  rules indicate things to be removed.)
</p>

<h2 id="Preface">Preface</h2>

<p>
  I've ordered my analyses according to how bad a library is.  The worst
  is first, and then we move up the spectrum.  I will point out the most
  flagrant problems with the libraries, but note that I will omit more
  advanced vulnerabilities: if you can't catch an <tt>onmouseover</tt>
  attribute, I really shouldn't reprimand you for letting non-<abbr>SGML</abbr> code
  points through.  The ideal solution, however, must do all these things.
</p>

<p>
  Note that besides striptags,
  most of the libraries are moderately effective against the most common <abbr>XSS</abbr>
  attacks.  None of them (save Safe HTML Checker) fare very well
  in the standards-compliance department though.
</p>

<h2 id="striptags">striptags()</h2>

<table class="summary">
  <tr><th>Whitelist</th>              <td class="impl-yes">Yes, user-specified</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-partial">Buggy</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-no">No</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-no">No</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-no">No</td></tr>
</table>

<p>
  The <abbr>PHP</abbr> function
  <a href="http://php.net/manual/en/function.strip-tags.php">striptags()</a> is
  the classic solution for attempting to clean up
  <abbr>HTML</abbr>.  It
  is also the <em>worst</em> solution, and should be avoided like the plague.
  The fact that it doesn't validate attributes at all means that anyone can
  insert an <tt>onmouseover='xss();'</tt> and exploit your application.
</p>

<p>
  While this can be bandaided with a series of regular expressions that strip out
  on[event] (you're still vulnerable to <abbr>XSS</abbr> and at the mercy of
  quirky browser behavior), striptags() is fundamentally flawed and should not be
  used.
</p>

<h2 id="Input_Filter">PHP Input Filter</h2>

<p>
  Though its title may not imply it,
  <a href="http://www.phpclasses.org/browse/package/2189.html">PHP Input Filter</a>
  is a souped up version of striptags() with the ability to inspect
  attributes.  (Don't mind the hastily tacked on query escaping function).
</p>

<table class="summary">
  <tr><th>Version</th>                <td class="impl-yes">1.2.2</td></tr>
  <tr><th>Last update</th>            <td class="impl-irrelevant">2005-10-05</td></tr>
  <tr><th>License</th>                <td class="impl-irrelevant">GPL</td></tr>
  <tr><th>Whitelist</th>              <td class="impl-yes">Yes, user defined</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-yes">Yes</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-no">No</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-no">No</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-partial">Partial</td></tr>
  <tr><th>XSS safe</th>               <td class="impl-almostyes">Probably</td></tr>
  <tr><th>Standards safe</th>         <td class="impl-no">No</td></tr>
</table>

<p>
  PHP Input Filter implements an
  <abbr>HTML</abbr> parser, and
  performs very basic checks on whether or not tags and attributes have
  been defined in the whitelist as well as some
  smarter <abbr>XSS</abbr> checks.  It is left up to
  the user to define what they'll permit.
</p>

<p>
  With absolutely no checking of well-formedness, it is trivially easy
  to trick the filter into leaving unclosed tags lying around. While to some
  standards-compliance may be viewed by some as a <q>nice feature</q>,
  basic sanity checks like this must be implemented, otherwise a user
  can mangle a website's layout.
</p>

<p>
  More troubles: Woe to
  any user that allows the <tt>style</tt> attribute: you can't simply
  just let <abbr>CSS</abbr> through and expect your
  layout not to be badly mutilated. To top things off,
  the filter doesn't even preserve data properly: attributes have all
  spaces stripped out of them.  Stay away, stay away!
</p>

<h2 id="HTML_Safe">HTML_Safe/SafeHTML</h2>

<p>
  <a href="http://pear.php.net/package/HTML_Safe">HTML_Safe</a> is
  <acronym>PEAR</acronym>'s <abbr>HTML</abbr> filtering library. 
  It should be noted that this is the same library as 
  <a href="http://pixel-apes.com/safehtml/">SafeHTML</a>, though with different
  branding (and a different version number).
</p>

<table class="summary">
  <tr><th>Version</th>                <td class="impl-almostyes">0.9.9beta</td></tr>
  <tr><th>Last update</th>            <td class="impl-irrelevant">2005-12-21</td></tr>
  <tr><th>License</th>                <td class="impl-irrelevant">BSD (3 clause)</td></tr>
  <tr><th>Whitelist</th>              <td class="impl-no">Mostly No</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-yes">Yes</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-yes">Yes</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-no">No</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-partial">Partial</td></tr>
  <tr><th>XSS safe</th>               <td class="impl-almostyes">Probably</td></tr>
  <tr><th>Standards safe</th>         <td class="impl-no">No</td></tr>
</table>

<p>
  HTML_Safe's mechanism of action involves parsing
  <abbr>HTML</abbr> with a
  <acronym>SAX</acronym> parser and performing
  validation and filtering as the handlers are called.  HTML_Safe does a lot
  of things right, which is why I say it <em>probably</em> isn't vulnerable
  to <abbr>XSS</abbr>, but its approach
  is fundamentally flawed: blacklists.
</p>

<p>
  This library maintains arrays of dangerous tags, attributes and
  <abbr>CSS</abbr> properties.  (It also
  has a blacklist of dangerous <abbr>URI</abbr> protocols, but this is
  intelligently disabled by default in favor of a protocol whitelist.)
  What this means is that HTML_Safe has no qualms of accepting input
  like <tt>&lt;foobar&gt; Bang &lt;/foobar&gt;</tt>.  Anything goes except
  the tags in those arrays.  Scratch standards-compliance (and that was
  without even considering proper nesting).
</p>

<p>
  For now, HTML_Safe might be safe from <abbr>XSS</abbr>.
  In the future, however, one of the infinitely many tags that HTML_Safe lets
  through might just possibly be given special functionality by browser vendors.
  And it might just turn out that this can be exploited.  <em>Any</em> blacklist
  solution puts you at a perpetual arms race against crackers who are constantly
  discovering new and inventive ways to abuse tags and attributes that you
  didn't blacklist.
</p>

<h2 id="kses">kses</h2>

<p>
  <a href="http://sourceforge.net/projects/kses/">kses</a> appears to
  be the de-facto solution for cleaning  <abbr>HTML</abbr>, having found
  its way into applications such as <a href="http://wordpress.org/">WordPress</a>
  and being the number one search result for <q>php html filter</q>.
</p>

<table class="summary">
  <tr><th>Version</th>                <td class="impl-partial">0.2.2</td></tr>
  <tr><th>Last update</th>            <td class="impl-irrelevant">2005-02-06</td></tr>
  <tr><th>License</th>                <td class="impl-irrelevant">GPL</td></tr>
  <tr><th>Whitelist</th>              <td class="impl-yes">Yes, user defined</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-yes">Yes</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-no">No</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-no">No</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-partial">Partial</td></tr>
  <tr><th>XSS safe</th>               <td class="impl-almostyes">Probably</td></tr>
  <tr><th>Standards safe</th>         <td class="impl-no">No</td></tr>
</table>

<p>
  To be truthful, I didn't do as comprehensive a code survey for kses
  as I did for some of the other libraries.  Out of
  all the classes I've reviewed so far, kses was definitely the hardest to
  understand.
</p>

<p>
  kses's modus operandi is splitting up html with a monster regexp
  and then validating each section with <tt>kses_split2()</tt>.  It
  suffers from the same problems as Input Filter: no well-formedness
  checks leading to rampant runaway tags (and no standards-compliance).
  WordPress, the primary user of kses today, had to implement their
  own custom tag-balancing code to fix this problem: don't use this
  library without some equivalent!
</p>

<p>
  Its whitelist syntax, however, is the most complex of all these libraries,
  so I'm going to take some time to argue why this particular implementation
  is bad.  The author of this library was thoughtful enough to provide some
  basic constraint checks on attributes like maxlen and maxval.  Now, barring
  the fact that there simply aren't enough checks, and the fact that they are
  all lumped together in one function, we now must wonder whether or not
  the user will go through the trouble of specifying the maximum length
  of a title attribute.
</p>

<p>
  I have my opinions about inherent human laziness, but perhaps WordPress's
  default filterset is the most telling example:
</p>

<pre>
$allowedposttags = array (
    /* formatted and trimmed */
    'hr' => array (
        'align' => array (),
        'noshade' => array (),
        'size' => array (),
        'width' => array ()
     )
);
</pre>

<p>
  Hmm... do I see a blatant lack of attribute constraints?  Conclusion:
  if the user can get away with not doing work, they will!  The biggest
  problem in all these whitelists filters is that they forgot to <em>supply</em>
  the whitelist.  The whitelist is just as important as the code that uses
  the whitelist to filter <abbr>HTML</abbr>.
</p>

<h2 id="htmLawed">htmLawed</h2>

<p>
  <a href="http://www.bioinformatics.org/phplabware/internal_utilities/htmLawed/index.php">htmLawed</a>
  is kses on steroids. After looking at HTML Purifier and deciding that it was
  too slow for him, Santosh Patnaik went ahead and rewrote the kses engine
  with more features.
</p>

<table class="summary">
  <tr><th>Version</th>                <td class="impl-yes">1.1.9.1</td></tr>
  <tr><th>Last update</th>            <td class="impl-irrelevant">2009-02-26</td></tr>
  <tr><th>License</th>                <td class="impl-irrelevant">GPL</td></tr>
  <tr><th>Whitelist</th>              <td class="impl-partial">Yes, but blacklist is default</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-almostyes">Yes, user defined</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-almostyes">Yes, user defined</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-no">Partial</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-partial">Partial</td></tr>
  <tr><th>XSS safe</th>               <td class="impl-no">Probably</td></tr>
  <tr><th>Standards safe</th>         <td class="impl-no">No</td></tr>
</table>

<p>
  htmLawed improves standards-compliance, but it is not fully
  standards-compliant; there are a number of cases which the author has
  explicitly stated he will not fix. There are issues with content
  models in <code>table</code> and <code>ruby</code> and tags that
  <em>must</em> have content in them.
</p>

<p>
  Let's, for a moment, imagine that htmLawed is <abbr>XSS</abbr>-safe when
  <code>safe</code> is on.
  Even then, it still is not <abbr>XSS</abbr>-safe out of the tin: you have
  to turn on htmLawed's security features! This is
  <a href="http://www.bioinformatics.org/phplabware/forum/viewtopic.php?id=28">by
  design</a>. Sane defaults are important, because for every person who
  does read the documentation, there is
  <a href="http://www.bioinformatics.org/phplabware/forum/viewtopic.php?id=28">another</a>
  one who doesn't (and is mislead by claims that <q>htmLawed is a single-file PHP
  software that makes input text secure</q>), and is
  surprised at some behavior.
  Software must be <strong>safe by default</strong>; the user can then relax
  any security restrictions.
</p>

<p>
  I also disagree with some of the choices with regards to what elements are
  <q>safe</q>. <code>form</code>
  is <abbr>XSS</abbr>-safe,
  but it is certainly not phishing safe. Forms can be
  used to spoof system dialogs <em>on that person's domain</em>. These should
  <em>not</em> be allowed in <code>safe</code> mode.
</p>

<h2 id="Safe_HTML_Checker">Safe HTML Checker</h2>

<p>
  <a href="http://simon.incutio.com/archive/2003/02/23/safeHtmlChecker">Safe
  HTML Checker</a> is (to my knowledge) the first attempt to make a filter
  that also outputs standards-compliant <abbr>XHTML</abbr>.  It wasn't even released or
  licensed officially, but we'll let that slide: a 4<sup>th</sup> place
  search result must have done something right.
</p>

<table class="summary">
    <tr><th>Version</th>                <td class="impl-partial">in-house</td></tr>
    <tr><th>Last update</th>            <td class="impl-almostyes">2003-09-15</td></tr>
    <tr><th>License</th>                <td class="impl-no">undefined</td></tr>
    <tr><th>Whitelist</th>              <td class="impl-partial">Yes (bare-bones)</td></tr>
    <tr><th>Removes foreign tags</th>   <td class="impl-yes">Yes</td></tr>
    <tr><th>Makes well-formed</th>      <td class="impl-yes">Yes</td></tr>
    <tr><th>Fixes nesting</th>          <td class="impl-almostyes">Almost</td></tr>
    <tr><th>Validates attributes</th>   <td class="impl-partial">Partial</td></tr>
    <tr><th>XSS safe</th>               <td class="impl-yes">Yes</td></tr>
    <tr><th>Standards safe</th>         <td class="impl-almostyes">Almost</td></tr>
</table>

<p>
  Indeed, it is quite a well-written piece of code.  It demonstrates
  knowledge of inline versus block elements, thus almost nearly getting
  nesting correct (the only exception is an unimplemented omitted SGML
  exclusion for <tt>&lt;a&gt;</tt> tags, and that's easy to fix).
</p>

<p>
  Unfortunately, part of the reason why it works so well is that it's
  extremely restrictive.  No styling, no tables, very few attributes.
  Perfectly appropriate for blog comments, but then again, there's always
  BBCode.  This probably means that Safe HTML Checker has a different
  goal than HTML Purifier.
</p>

<p>
  The <abbr>XML</abbr> parser is also quite strict. Accidentally missed a 
  &lt; sign? The parser will complain with the cryptic message: 
  <q><abbr>XHTML</abbr> is not well-formed</q>. The solution is not as 
  simple as just switching to a more permissive parser: Safe HTML Checker 
  relies on the fact that the parser will have matched up the tags for 
  them.
</p>

<h2 id="HTMLPurifier">HTML Purifier</h2>

<table class="summary">
  <tr><th>Version</th>                <td class="impl-yes">&htmlpurifier.current.version;</td></tr>
  <tr><th>Last update</th>            <td class="impl-yes">&htmlpurifier.current.release-date;</td></tr>
  <tr><th>License</th>                <td class="impl-irrelevant">LGPL</td></tr>
  <tr><th>Whitelist</th>              <td class="impl-yes">Yes</td></tr>
  <tr><th>Removes foreign tags</th>   <td class="impl-yes">Yes</td></tr>
  <tr><th>Makes well-formed</th>      <td class="impl-yes">Yes</td></tr>
  <tr><th>Fixes nesting</th>          <td class="impl-yes">Yes</td></tr>
  <tr><th>Validates attributes</th>   <td class="impl-yes">Yes</td></tr>
  <tr><th>XSS safe</th>               <td class="impl-yes">Yes</td></tr>
  <tr><th>Standards safe</th>         <td class="impl-yes">Yes</td></tr>
</table>

<p>
  That table should say it all, but I'll add a few more features:
  </p>

<table class="summary">
  <tr><th>UTF-8 aware</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Object-Oriented</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Validates CSS</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Tables</th><td class="impl-yes">Yes</td></tr>
  <tr><th>PHP 5 only</th><td class="impl-yes">Yes</td></tr>
  <tr><th>E_STRICT compliant</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Can auto-paragraph</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Extensible</th><td class="impl-yes">Yes</td></tr>
  <tr><th>Unit tested</th><td class="impl-yes">Yes</td></tr>
</table>

<p>
  This is not to say that HTML Purifier doesn't have problems of its own.
  It's big (while the others usually fit in one file, this one requires a huge
  include list), and it's <a href="http://htmlpurifier.org/live/TODO">missing
  features.</a> But even with these deficiencies,
  HTML Purifier is far better than the other libraries.
</p>

<p>
  So... <a href="download">what are you waiting for?</a>
</p>

</div>
</div>
</body>
</html>
